from ZODB.POSException import ConflictError
from DateTime import DateTime


def makeEvent(context, id, type_name, title, description, eventType, dt_start, dt_end, dt_recur_end, text, attendees, location, recurEvent, recurUpdate, recurFreq, recurWeek, recurLast, contactName, contactEmail, contactPhone, eventUrl, relatedItems, allowDiscussion):
    if not id:
	  id=context.generateUniqueId(type_name)
    try:
        ob = context.invokeFactory(id=id, type_name=type_name)
        o = getattr(context,id)
        o.edit( title=title
                , description=description
                , eventType=eventType
                , effectiveYear=dt_start.year()
                , effectiveMo=dt_start.month()
                , effectiveDay=dt_start.day()
                , expirationYear=dt_end.year()
                , expirationMo=dt_end.month()
                , expirationDay=dt_end.day()
                , lastYear=dt_recur_end.year()
                , lastMo=dt_recur_end.month()
                , lastDay=dt_recur_end.day()
                , start_time='%0.2d:%0.2d'%(dt_start.h_24(), dt_start.minute())
                , startAMPM=dt_start.ampm()
                , stopAMPM=dt_end.ampm()
                , stop_time='%0.2d:%0.2d'%(dt_end.h_24(), dt_end.minute())
                , location=location
				, text=text
				, attendees=attendees
                , recurEvent=recurEvent
                , recurUpdate = recurUpdate
                , recurFreq=recurFreq
                , recurWeek=recurWeek
				, recurLast=recurLast
                , contact_name=contactName
                , contact_email=contactEmail
                , contact_phone=contactPhone
                , event_url=eventUrl
				, relatedItems=relatedItems
				, allowDiscussion=allowDiscussion )
        o.plone_utils.contentEdit( o, id=id, description=description)
        #o.content_status_modify(workflow_action='publish')
    except ConflictError:
        raise

